// 񂱂񂱁`

#include "stdafx.h"
#include <winsock2.h>

//------------------------------------------------------------------------

// T[oAhX
#define SERVER_ADDRESS			"127.0.0.1"

// T[o|[g
#define SERVER_PORT				27015

//------------------------------------------------------------------------

// őpPbgTCY
#define MAX_OF_PACKET_SIZE		1400

// őpPbg
#define MAX_OF_PACKET_COUNT		15

// őpPbgԍ
#define MAX_OF_PACKET_NUMBER	(MAX_OF_PACKET_COUNT - 1)

// Mobt@TCY
#define RBUFFER_SIZE			(MAX_OF_PACKET_SIZE * MAX_OF_PACKET_COUNT)

// 񕪊f[^ʃR[h
#define SINGLE_PACKET_CODE		0xFFFFFFFF
// f[^ʃR[h
#define DEVIDED_PACKET_CODE		0xFFFFFFFE

// ^CAEg
#define RECEIVE_TIMEOUT		2000

// ʐMNX
class CA2SCommunicator {
private:
	// f[^obt@
	char *m_DataBuffer;
	// ڑĂH
	bool m_Connected;
	// \Pbg
	SOCKET m_Socket;
	// f[^TCY
	int m_DataSize;
	// f[^CfNX
	int m_DataIndex;
public:
	// RXgN^
	CA2SCommunicator() {
		// ȂĂȂ
		m_Connected = false;

		// f[^˂
		m_DataSize = 0;

		// \zf[^̈pӂႦ
		m_DataBuffer = new char[RBUFFER_SIZE];
	}
	// fXgN^
	~CA2SCommunicator() {
		if (m_Connected) {
			// ȂĂȂؒf
			Disconnect();
		}
		delete m_DataBuffer;
	}	

	// T[oɐڑ
	bool Connect(const char* hostAddress, int port);

	// ؒf
	void Disconnect() {
		closesocket(m_Socket);
		WSACleanup();
		m_Connected = false;
	}

	// ȂĂH
	bool HasConnected() {
		return m_Connected;
	}

	// f[^́H
	bool IsAvailableData() {
		return (m_DataSize > 0);
	}

	// M
	bool SendData(const char *buffer, int size, bool setHeader = true);
	// M
	bool ReceiveData();

private:
	// f[^Rs[
	bool DataCopy(void *target, int size) {
		if ((m_DataSize - m_DataIndex) < size) {
			// oȂ
			return false;
		}
		memcpy(target, &m_DataBuffer[m_DataIndex], size);
		m_DataIndex += size;
		return true;
	}

public:
	// f[^o
	template<class T>
	bool GetData(T *data) {
		return DataCopy(data, sizeof(T));
	}

	// stringo
	bool GetString(char **data) {
		static char tempChar[255];
		wchar_t tempWchar[255];
		memset(tempChar, 0, sizeof(tempChar));
		memset(tempWchar, 0, sizeof(tempWchar));

		if ((m_DataSize - (m_DataIndex + strlen(&m_DataBuffer[m_DataIndex]) + 1)) < 0) {
			// oȂ
			return false;
		}

		// Unicodeϊ
		MultiByteToWideChar(
			CP_UTF8,
			0,
			&m_DataBuffer[m_DataIndex],
			(signed)strlen(&m_DataBuffer[m_DataIndex]),
			tempWchar,
			sizeof(tempWchar)
		);

		// ANSIϊ
		WideCharToMultiByte(
						CP_ACP,
						WC_NO_BEST_FIT_CHARS,
						tempWchar,
						(signed)wcslen(tempWchar),
						tempChar,
						sizeof(tempChar),
						NULL,
						NULL
						);

		*data = tempChar;
		m_DataIndex += (signed)(strlen(&m_DataBuffer[m_DataIndex]) + 1);
		return true;
	}

	// f[^\
	template<class T>
	bool ShowData(char *caption, T *data) {
		T tempData;
		bool available = DataCopy(&tempData, sizeof(tempData));
		if (available) {
			printf(caption, tempData);
			printf("\n");
		}
		if (data != NULL) {
			*data = tempData;
		}
		return available;
	}

	// string\
	bool ShowString(char *caption, char **data) {
		char* tempData;
		bool available = GetString(&tempData);
		if (available) {
			printf(caption, tempData);
			printf("\n");
		}
		if (data != NULL) {
			*data = tempData;
		}
		return available;
	}
};

// T[oɐڑ
bool CA2SCommunicator::Connect(const char* hostAddress, int port) {
	if (m_Connected) {
		printf("Connect:qĂ񂾂oJI\n");			
	}

	// ݂ȂĂWinSock̃o[WmFĂ݂
	WORD wVersionRequested = MAKEWORD( 2, 2 );
	WSADATA wsaData;
	int err = WSAStartup( wVersionRequested, &wsaData );
	if(err != 0){
		printf("Connect:WSAStartup߂\n");;
		return false;
	}

	// Socket
	m_Socket = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if(m_Socket == INVALID_SOCKET ){
		printf("Connect:socket߂\n");
		return false;
	}

	// M^CAEgԐݒ
	long timeout = RECEIVE_TIMEOUT;
	setsockopt(m_Socket, SOL_SOCKET, SO_RCVTIMEO, (char*)&timeout, sizeof(timeout));

	// Ȃ
	sockaddr_in sockAddr;
	memset(&sockAddr, 0, sizeof(sockAddr));
	sockAddr.sin_family = AF_INET;
	sockAddr.sin_addr.s_addr = inet_addr(hostAddress);
	sockAddr.sin_port = htons(port);

	err = connect(m_Socket, (const sockaddr *)&sockAddr, sizeof(sockAddr)); 
	if(err == SOCKET_ERROR ){
		printf("Connect:connect߂\n");
		WSACleanup();
		return false;
	}

	// (ÉE)Ȃ`
	m_Connected = true;
	return true;
}

// M
bool CA2SCommunicator::SendData(const char *buffer, int size, bool setHeader) {
	if (!m_Connected) {
		printf("SendData:qĂ˂{PI\n");			
	}

	int offset = 0;
	long packetCode = SINGLE_PACKET_CODE;
	char tempBuffer[MAX_OF_PACKET_SIZE];
	memset(tempBuffer, 0, sizeof(tempBuffer));

	// Mobt@쐬
	if (setHeader) {
		// wb_}̎wꍇ̂
		memcpy(tempBuffer, &packetCode, sizeof(packetCode));
		offset += sizeof(packetCode);
	}
	memcpy(&tempBuffer[offset], buffer, size);

	int err = send(m_Socket, tempBuffer, size + offset, 0);
	if(err == SOCKET_ERROR ){
		printf("SendData:send߂\n");
		return false;
	}
	return true;
}

// M
bool CA2SCommunicator::ReceiveData() {
	if (!m_Connected) {
		printf("ReceiveData:qĂ˂{PI\n");			
	}

	// TCY
	m_DataSize = 0;

	// obt@
	memset(m_DataBuffer, 0, RBUFFER_SIZE);

	// Pڂ̃pPbgM
	long packetCode;
	char tempBuffer[MAX_OF_PACKET_SIZE];
	int dataSize = recv(m_Socket, tempBuffer, sizeof(tempBuffer), 0);
	if (dataSize < (signed)sizeof(packetCode)) {
		// Œ4oCgȂƂ
		printf("ReceiveData:Mf[^Ȃ\n");
		return false;
	}

	// 擪̃R[h
	memcpy(&packetCode, tempBuffer, sizeof(packetCode));

	if (packetCode == SINGLE_PACKET_CODE) {
		// 񕪊f[^
		m_DataSize = dataSize - sizeof(packetCode);
		memcpy(m_DataBuffer, &tempBuffer[sizeof(packetCode)], m_DataSize);

		// f[^CfbNX
		m_DataIndex = 0;
		return true;
	} else if (packetCode != DEVIDED_PACKET_CODE) {
		// R[hĂ
		printf("ReceiveData:R[hĂ:%d\n", packetCode);
		return false;
	} else if (dataSize < (sizeof(long) * 2 + sizeof(char))) {
		// wb_͂ToCgȂƂ
		printf("ReceiveData:wb_TCYs\n");
		return false;
	}

	// ꕪf[^̏Rs[
	long requestID = 0;
	long totalPacket;
	long currentPacket;

	// c̃pPbg̃f[^
	for (int i = 0; i < MAX_OF_PACKET_COUNT; i++) {
		if (i > 0) {
			// 1Ԉȍ~̃pPbgM(0Ԃ͂Ă)
			dataSize = recv(m_Socket, tempBuffer, sizeof(tempBuffer), 0);
		}

		int offset = 0;

		// R[h
		memcpy(&packetCode, tempBuffer, sizeof(packetCode));
		offset += sizeof(packetCode);

		// vID
		long oldRequestID = requestID;
		memcpy(&requestID, &tempBuffer[offset], sizeof(requestID));
		offset += sizeof(requestID);

		// SpPbg
		totalPacket = (tempBuffer[offset] & 0x0F);
		// ݂̃pPbgԍ
		currentPacket = (tempBuffer[offset] & 0xF0) >> 4;
		offset += sizeof(char);

		if (currentPacket != i) {
			printf("ReceiveData:pPbgԍĂ\n");
			return false;
		} else if (totalPacket < 2 || totalPacket <= currentPacket) {
			printf("ReceiveData:pPbgĂ\n");
			return false;
		} else if ( i > 0 && oldRequestID != requestID) {
			printf("ReceiveData:vID̈قȂpPbg荞ł\n");
		}
		memcpy(&m_DataBuffer[m_DataSize], &tempBuffer[offset], (dataSize - offset));
		m_DataSize += (dataSize - offset);
	}

	// f[^CfbNX
	m_DataIndex = 0;
	return true;
}

//------------------------------------------------------------------------

// A2S_SERVERQUERY_GETCHALLENGE
#define A2S_SERVERQUERY_GETCHALLENGE {	\
	'W'									\
}
#define A2S_SERVERQUERY_GETCHALLENGE_RES	'A'

// A2S_INFO
#define A2S_INFO {						\
	'T',"Source Engine Query"			\
}
#define A2S_INFO_RES						'I'

// A2S_PLAYER
#define A2S_PLAYER {					\
	'U', 0x00, 0x00, 0x00, 0x00			\
}
#define A2S_PLAYER_RES						'D'

// A2S_RULES
#define A2S_RULES {						\
	'V', 0x00, 0x00, 0x00, 0x00			\
}
#define A2S_RULES_RES						'E'

//------------------------------------------------------------------------

// O[oN
CA2SCommunicator g_Com;

//------------------------------------------------------------------------

// A2S_SERVERQUERY_GETCHALLENGE
bool GetChallengeNumber(long &challengeNumber) {
	bool aborted = false;

	// M
	char request[] = A2S_SERVERQUERY_GETCHALLENGE;
	aborted = !g_Com.SendData(request, sizeof(request));

	if (!aborted) {
		// M
		aborted = !g_Com.ReceiveData();
	}
	if (!aborted && g_Com.IsAvailableData()) {
		// X|XR[h
		char responseCode = '\0';
		aborted = !g_Com.GetData(&responseCode);
		aborted = (aborted || responseCode != A2S_SERVERQUERY_GETCHALLENGE_RES);
		if (!aborted) {
			// ₢킹ԍ擾
			aborted = !g_Com.ShowData("[₢킹ԍ] %08X", &challengeNumber);
//				g_Com.GetData(&challengeNumber);
		}
	}
	return !aborted;
}

// A2S_INFO
bool GetServerInfo() {
	bool aborted = false;

	// M
	char request[] = A2S_INFO;
	aborted = !g_Com.SendData(request, sizeof(request));

	if (!aborted) {
		// M
		aborted = !g_Com.ReceiveData();
	}
	if (!aborted && g_Com.IsAvailableData()) {
		// X|XR[h
		char responseCode = '\0';
		aborted = !g_Com.GetData(&responseCode);
		aborted = (aborted || responseCode != A2S_INFO_RES);
		if (!aborted) {
			int errCount = 0;
			// T[ooA\
			char tempChar;
			short tempShort;

			errCount += !g_Com.ShowData("[o[W] %02X", &tempChar);
			errCount += !g_Com.ShowString("[T[o] %s", NULL);
			errCount += !g_Com.ShowString("[}bv] %s", NULL);
			errCount += !g_Com.ShowString("[Q[fBNg] %s", NULL);
			errCount += !g_Com.ShowString("[Q[̐] %s", NULL);
			errCount += !g_Com.ShowData("[AppID] %d", &tempShort);
			errCount += !g_Com.ShowData("[vC[] %d", &tempChar);
			errCount += !g_Com.ShowData("[ővC[] %d", &tempChar);
			errCount += !g_Com.ShowData("[BOT] %d", &tempChar);
			errCount += !g_Com.ShowData("[T[oғ[h] %c", &tempChar);
			errCount += !g_Com.ShowData("[OS] %c", &tempChar);
			errCount += !g_Com.ShowData("[pX[hv] %02X", &tempChar);
			errCount += !g_Com.ShowData("[ZLeB[Kp] %02X", &tempChar);
			errCount += !g_Com.ShowString("[Q[o[W] %s", NULL);

			aborted = (errCount > 0);
		}
	}
	return !aborted;

}

// A2S_PLAYER
bool GetPlayer(long challengeNumber) {
	bool aborted = false;

	// M
	char request[] = A2S_PLAYER;
	memcpy(&request[sizeof(char)], &challengeNumber, sizeof(challengeNumber));
	aborted = !g_Com.SendData(request, sizeof(request));

	if (!aborted) {
		// M
		aborted = !g_Com.ReceiveData();
	}
	if (!aborted && g_Com.IsAvailableData()) {
		// X|XR[h
		char responseCode = '\0';
		aborted = !g_Com.GetData(&responseCode);
		aborted = (aborted || responseCode != A2S_PLAYER_RES);
		if (!aborted) {
			char playerCount = 0;
			int errCount = 0;

			// T[ooA\
			char tempChar;
			long tempLong;
			float tempFloat;

			errCount += !g_Com.ShowData("[vC[] %d", &playerCount);

			for (int i = 0; i < playerCount && errCount == 0; i++) {
				errCount += !g_Com.ShowData("@[vC[ԍ] %d", &tempChar);
				errCount += !g_Com.ShowString("@[vC[] %s", NULL);
				errCount += !g_Com.ShowData("@[tbO] %d", &tempLong);
				errCount += !g_Com.ShowData("@[ڑ] %.1f", &tempFloat);
			}
			aborted = (errCount > 0);
		}
	}
	return !aborted;
}

// A2S_RULES
bool GetRules(long challengeNumber) {
	bool aborted = false;

	// M
	char request[] = A2S_RULES;
	memcpy(&request[sizeof(char)], &challengeNumber, sizeof(challengeNumber));
	aborted = !g_Com.SendData(request, sizeof(request));

	if (!aborted) {
		// M
		aborted = !g_Com.ReceiveData();
	}
	if (!aborted && g_Com.IsAvailableData()) {
		// X|XR[h
		char responseCode = '\0';
		aborted = !g_Com.GetData(&responseCode);
		aborted = (aborted || responseCode != A2S_RULES_RES);
		if (!aborted) {
			short ruleCount = 0;
			int errCount = 0;

			// T[ooA\
			errCount += !g_Com.ShowData("[[] %d", &ruleCount);

			for (int i = 0; i < ruleCount && errCount == 0; i++) {
				errCount += !g_Com.ShowString("@[[] %s", NULL);
				errCount += !g_Com.ShowString("@[[ݒl] %s", NULL);
			}
			aborted = (errCount > 0);
		}
	}
	return !aborted;
}

// ߁[[[
int _tmain(int argc, _TCHAR* argv[])
{
	// ₢킹ԍ
	long challengeNumber;

	// ڑ
	bool aborted = !g_Com.Connect(SERVER_ADDRESS, SERVER_PORT);

	//-------------------------------------
	// A2S_SERVERQUERY_GETCHALLENGE
	//-------------------------------------
	if (!aborted) {
		printf("ssA2S_SERVERQUERY_GETCHALLENGEtt\n");
		aborted = !GetChallengeNumber(challengeNumber);
	}

	//-------------------------------------
	// A2S_INFO
	//-------------------------------------
	if (!aborted) {
		printf("ssA2S_INFOtt\n");
		aborted = !GetServerInfo();
	}

	//-------------------------------------
	// A2S_PLAYER
	//-------------------------------------
	if (!aborted) {
		printf("ssA2S_PLAYERtt\n");
		aborted = !GetPlayer(challengeNumber);
	}

	//-------------------------------------
	// A2S_RULES
	//-------------------------------------
	if (!aborted) {
		printf("ssA2S_RULEStt\n");
		aborted = !GetRules(challengeNumber);
	}

	// ؒf
	g_Com.Disconnect();

	if (aborted) {
		printf("G[Ă܂B\n");
	}
	return 0;
}

